/* ccgo: igs/line_box.hh
 * 
 * Copyright (C) 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of ccGo.
 * 
 * ccGo is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef IGS_LINE_BOX_HH
#define IGS_LINE_BOX_HH
#include <gtkmm/entry.h>
#include <string>
#include <vector>
namespace igs
{
	class LineBox :
		public Gtk::Entry
	{
		bool on_key_press_event(GdkEventKey *);
		void on_activate();
		std::vector<std::string> hist;
		std::vector<std::string>::reverse_iterator ri;
		std::string current_line;
	public:
		LineBox();
		void clear_history();
		const std::string & get_line();
	};
}
#endif // IGS_LINE_BOX_HH
