/* ccgo: igs/parser/match_start.hh
 * 
 * Copyright (C) 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of ccGo.
 * 
 * ccGo is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef IGS_PARSER_MATCH_START_HH
#define IGS_PARSER_MATCH_START_HH
#include "parser.hh"
namespace igs
{
	namespace parser
	{
		class MatchStart :
			public Parser
		{
			virtual Parser * id(Control *) const;
			bool complete;
			int game;
			std::string who;
			bool accepted;
			bool parse_head();
		public:
			MatchStart(Parser *);
			MatchStart(Control *);
			virtual ~MatchStart();
			virtual bool process();
			static MatchStart parser_match_start;
		};
	}
}
#endif // IGS_PARSER_MATCH_START_HH
