/* ccgo: igs/static.hh
 * 
 * Copyright (C) 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of ccGo.
 * 
 * ccGo is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef IGS_STATIC_HH
#define IGS_STATIC_HH
#include "../view_game.hh"
#include "board.hh"
#include <gtkmm/window.h>
#include <gtkmm/label.h>
namespace igs {
	// class to show static game board
	class Static :
		public Gtk::Window
	{
		Gtk::Label head_line;
		go::ViewGame board;
		Gtk::Label date;
		Gtk::Label record;

		void on_hide();

		int my_width;
		int my_height;
		void on_size_allocate(Gtk::Allocation &);
	public:
		Static(unsigned);
		void set_board(const Board &);
	};
}
#endif // IGS_STATIC_HH
