/* ccgo: proper_node.hh
 * 
 * Copyright (C) 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of ccGo.
 * 
 * ccGo is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef PROPER_NODE_HH
#define PROPER_NODE_HH
#include "node.hh"
#include "game.hh"
#include "proper.hh"
namespace go {
	class ProperNode :
		virtual public Node
	{
		Proper * proper;
	protected:
		virtual Node * create_copy() const;
	public:
		ProperNode();
		~ProperNode();
		virtual void set_proper(const Game &, Proper * = NULL);
		void set_proper(Proper *);
		const Proper * get_proper() const;
		Proper * get_proper();
	};
}
#endif // PROPER_NODE_HH
