/* ccgo: score_proper.hh
 * 
 * Copyright (C) 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of ccGo.
 * 
 * ccGo is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef SCORE_PROPER_HH
#define SCORE_PROPER_HH
#include "proper.hh"
namespace go
{
	class ScoreProper :
		virtual public Proper
	{
		unsigned board_size;
		Terri * terri;
		unsigned terri_score_w;
		unsigned terri_score_b;
	public:
		ScoreProper();
		ScoreProper(const ScoreProper &);
		~ScoreProper();
		virtual Proper * dup() const;
		void set_terri(const Game &, Terri *);
		const Terri * get_terri() const;
		unsigned get_terri_score_w() const;
		unsigned get_terri_score_b() const;
	};
}
#endif // SCORE_PROPER_HH
